/* amiCheck to Final Data EXPORT macro                           */
/* start amicheck, start final data.  Create a database in       */
/* final data with the following fields:                         */
/* text, text, text, text, amount (with TWO decimal places!)     */
/* Then open an account and run the macro!                       */

OPTIONS RESULTS

/* load arexx library for functions */
IF ( ADDLIB("rexxsupport.library", 0, -30, 0) = FALSE) THEN EXIT 20

/* grab the ports */
ACPort = ADDRESS()

/* find final data */
FDPortBase = "FINALD."
found = 0
DO p = 1 TO 50
   IF ( SHOWLIST('P', FDPortBase || p) ) THEN DO
      FDPort = FDPortBase || p
      found = 1
      LEAVE
   END
END

/* did we nab it? */
if ( ~ found) THEN DO
	EXIT
END

/* number of records */
address VALUE ACPort
AC_GETINFO ENTRIES
entries = Result

/* lock amicheck */
address VALUE ACPort
AC_Lock

/* now for each record... */
IF (entries > 0) THEN DO
	DO i=1 TO entries
		address VALUE ACPort
			AC_GETRECORD i TYPE
			Record.Type = Result

			AC_GETRECORD i NAME
			Record.Name = Result

			AC_GETRECORD i MEMO
			Record.Memo = Result

			AC_GETRECORD i DATE
			Record.Date = Result
			
			AC_GETRECORD i AMOUNT
			Record.Amount = Result
			
			AC_GETRECORD i CHECKNUMBER
			Record.Check = Result

			/* is this + or -? */
			if (Record.Type ~= 2 ) then Record.Amount = Record.Amount * -1
		

		address VALUE FDPort
			NewRow
			IF (Record.Type = 0) THEN Insert DATA Record.Check
			IF (Record.Type = 1) THEN Insert DATA "Withdrawal"
			IF (Record.Type = 2) THEN Insert DATA "Deposit"
				
			NextCell
			Insert DATA Record.Name

			NextCell
			Insert DATA Record.Memo 

			NextCell
			Insert DATA Record.Date

			NextCell
			Insert DATA Record.Amount
	
	END
END

/* unlock amicheck */
address VALUE ACPort
AC_Unlock
