   
/* mainPanel.c 
*
*  defines the GUIFront characteristics of the main panel 
*/
  
#include <libraries/guifront.h>
#include <intuition/gadgetclass.h>
#include "amiCheck.h"
#include "mainPanel.h"

/* define imagery tags */

struct TagItem getScrollerTypes[] =
{
        {PGA_Freedom, LORIENT_VERT},          
	{GA_Immediate, TRUE},
        {TAG_DONE},
};

struct TagItem usrTypeField[] =
{
        {GTTX_Border, TRUE},
        {GTTX_Text,"Check"}, 
        {TAG_DONE},
};

struct TagItem defaultEditTag[] =
{
	{GA_Disabled, TRUE},
	{TAG_DONE},
};

/* define gadgetspec */
GadgetSpec gadgetspecs[] = 
{

        {TEXT_KIND,50,1,{0,0,0,0,NULL,NULL,GID_REGHEADER,
                PLACETEXT_IN}, TxtNoBorder,GS_DefaultTags},
                
        {TEXT_KIND,50,10,{0,0,0,0, NULL,NULL,GID_REGFIELD,
                PLACETEXT_IN}, TxtBorder, GS_DefaultTags},

        {SCROLLER_KIND,0,1,{0,0,0,0, NULL,NULL,GID_REGVSCROL,
                PLACETEXT_IN}, getScrollerTypes, GS_DefaultTags},

        {TEXT_KIND,  12,0,{0,0,0,0,"Curr",NULL, GID_CURRBAL,
                PLACETEXT_LEFT}, TxtZero, GS_DefaultTags},

        {TEXT_KIND,  12,0,{0,0,0,0,"Stmt",NULL,GID_STATBAL,
                PLACETEXT_LEFT}, TxtZero, GS_DefaultTags},

        {TEXT_KIND,  10,0,{0,0,0,0,NULL,NULL,GID_SELTYPE,
                PLACETEXT_LEFT}, usrTypeField, GS_DefaultTags},

        {GETALT_KIND, 0,0,{0,0,0,0,NULL,NULL,GID_GETSELTYPE,
                PLACETEXT_LEFT}, MiscButton, GS_DefaultTags},   

        {BUTTON_KIND,0,0,{0,0,0,0,"T_rend", NULL, GID_TREND, 
                PLACETEXT_IN}, NULL, GS_DefaultTags},
                
        {BUTTON_KIND,0,0,{0,0,0,0,"Enter _Data", NULL, GID_ENTERTYPE, 
                PLACETEXT_IN}, NULL, GS_DefaultTags},
                
        {BUTTON_KIND,0,0,{0,0,0,0,"_Templates", NULL, GID_NEWTYPE, 
                PLACETEXT_IN}, NULL, GS_DefaultTags},
                
        {BUTTON_KIND,0,0,{0,0,0,0,"_Filter Register", NULL, GID_FILTER, 
                PLACETEXT_IN}, NULL, GS_DefaultTags},
                
        {BUTTON_KIND,0,0,{0,0,0,0,"_Edit Entry", NULL, GID_EDIT, 
                PLACETEXT_IN}, NULL, GS_DefaultTags},

        {BUTTON_KIND,0,0,{0,0,0,0,"Stat_istics", NULL, GID_STATS, 
                PLACETEXT_IN}, NULL, GS_DefaultTags},

        {BUTTON_KIND,0,0,{0,0,0,0,"_Budget", NULL, GID_BUDGET, 
                PLACETEXT_IN}, NULL, GS_DefaultTags},

        {BUTTON_KIND,0,0,{0,0,0,0,"_Analysis", NULL, GID_ANALYSIS, 
                PLACETEXT_IN}, NULL, GS_DefaultTags},

        {BUTTON_KIND,0,0,{0,0,0,0,"_Sort Register", NULL, GID_SORT, 
                PLACETEXT_IN}, NULL, GS_DefaultTags},            

        {TEXT_KIND,  12,0,{0,0,0,0,"Fltr",NULL,GID_RUNBAL,
                PLACETEXT_LEFT}, TxtZero, GS_DefaultTags},  
};


/* set up array of pointers to our specs */
GadgetSpec *AC_MainSpecs[] =
{
        &gadgetspecs[0],
        &gadgetspecs[1],
        &gadgetspecs[2],
        &gadgetspecs[3],
        &gadgetspecs[4],
        &gadgetspecs[5],
        &gadgetspecs[6],
        &gadgetspecs[7],
        &gadgetspecs[8],
        &gadgetspecs[9],
        &gadgetspecs[10],
        &gadgetspecs[11],
        &gadgetspecs[12],
        &gadgetspecs[13],
        &gadgetspecs[14],
        &gadgetspecs[15],
	&gadgetspecs[16],
        NULL,
};


/* define the layout of this panel */
ULONG AC_MainPanel[] =
{
   GUIL_Flags, GUILF_PropShare | GUILF_EqualWidth,
   
        GUIL_VertGroup,1,
                GUIL_FrameType, GUILFT_Ridge,
                GUIL_FrameHeadline, "Register Filter",
        
                GUIL_GadgetSpecID, GID_REGHEADER,
                
                GUIL_HorizGroup,1,
                
                        GUIL_GadgetSpecID, GID_REGFIELD,
                        GUIL_GadgetSpecID, GID_REGVSCROL,
                TAG_DONE,
        TAG_DONE,
     
        GUIL_HorizGroup,1,
                GUIL_Flags, GUILF_EqualShare,
 
                GUIL_VertGroup,1,
                        GUIL_Flags, GUILF_EqualHeight | GUILF_LabelAlign, 
                        GUIL_FrameType, GUILFT_Ridge,
                        GUIL_FrameHeadline, "Balances",
                   
		        GUIL_GadgetSpecID, GID_RUNBAL,
                        GUIL_GadgetSpecID, GID_CURRBAL,
                        GUIL_GadgetSpecID, GID_STATBAL,
                   
                                      
                TAG_DONE,
       
                GUIL_VertGroup,1,
                        GUIL_Flags, GUILF_EqualHeight, 
                        GUIL_FrameType, GUILFT_Ridge,
                        GUIL_FrameHeadline, "Data Entry",
                   
                        GUIL_HorizGroup, 0,
                                GUIL_Flags, GUILF_PropShare | GUILF_EqualHeight,
                              
                                GUIL_GadgetSpecID, GID_SELTYPE,
                                GUIL_GadgetSpecID, GID_GETSELTYPE,
                        TAG_DONE,
                        
                        GUIL_GadgetSpecID, GID_NEWTYPE,
                        GUIL_GadgetSpecID, GID_BUDGET,
        
                TAG_DONE,
   
                GUIL_VertGroup,1,
                        GUIL_Flags, GUILF_EqualHeight, 
                        GUIL_FrameType, GUILFT_Ridge,
                        GUIL_FrameHeadline, "Register",
                   
                        GUIL_GadgetSpecID, GID_EDIT,
                        GUIL_GadgetSpecID, GID_FILTER,
                        GUIL_GadgetSpecID, GID_SORT,
                        
                TAG_DONE,
                
                GUIL_VertGroup,1,
                        GUIL_Flags, GUILF_EqualHeight, 
                        GUIL_FrameType, GUILFT_Ridge,
                        GUIL_FrameHeadline, "Report",
                   
                        GUIL_GadgetSpecID, GID_TREND,
                        GUIL_GadgetSpecID, GID_ANALYSIS,
                        GUIL_GadgetSpecID, GID_STATS,
                                                
                TAG_DONE,

        TAG_DONE,     
           
   TAG_DONE,
};


/* some globals only pulled in by the main routine */
int AC_InitialOrientation = GUIL_VertGroup;
